import 'package:flutter/material.dart';
import 'package:flutter_widegt_wangyan/flutter_widegt_wangyan.dart';

void main() => runApp(MyApp());

class MyApp extends StatelessWidget {
  // This widget is the root of your application.
  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      title: 'Flutter Demo',
      theme: ThemeData(
        primarySwatch: Colors.blue,
      ),
      home: MyHomePage(),
    );
  }
}

class MyHomePage extends StatelessWidget {
  const MyHomePage({Key key}) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        title: Text("测试页面"),
      ),
      body: Container(
          color: Colors.white,
          child: Row(
            mainAxisAlignment: MainAxisAlignment.start,
            crossAxisAlignment: CrossAxisAlignment.start,
            children: <Widget>[
              WyButton(
                onClick: () {
                  WyToast(context, message: "提示文字", position: Position.bottom);
                },
              ),
              WyButton(
                onClick: () async {
                  WyToast.loading(context, message: "登录中", duration: 0);

                  await Future.delayed(Duration(seconds: 2));
                  WyToast.remove();
                },
              ),
              WyButton(
                type: ButtonType.info,
                onClick: () {
                  WyToast.success(context, message: '操作成功');
                },
              ),
              WyButton(
                type: ButtonType.danger,
                onClick: () {
                  WyToast(context,
                      overlay: true,
                      position: Position.bottom,
                      animationTime: Duration(milliseconds: 300),
                      message: 'ppp', iconBuilder: (context) {
                    return Image.asset("images/logo.png");
                  });
                },
              )
            ],
          )),
    );
  }
}
